﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;

namespace ColumnHidingMVVM
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
    }

    public class MainPageViewModel : PropertyChangedNotifier
    {
        public MainPageViewModel()
        {
            GridData = new ObservableCollection<DataViewModel>();
            for (int i = 0; i < 10; i++)
            {
                GridData.Add(new DataViewModel
                {
                    ID = i,
                    Name = "Name " + i,
                    Email = "name" + i + "@infragistics.com",
                    Age = 20 + (i % 4)
                });
            }

            IDVisibility = Visibility.Visible;
            EmailVisibility = Visibility.Visible;
        }

        private ObservableCollection<DataViewModel> data;

        public ObservableCollection<DataViewModel> GridData
        {
            get { return data; }
            set { data = value; }
        }

        private Visibility idVis;

        public Visibility IDVisibility
        {
            get { return idVis; }
            set { idVis = value; OnPropertyChagned("IDVisibility"); }
        }

        private Visibility emailVis;

        public Visibility EmailVisibility
        {
            get { return emailVis; }
            set { emailVis = value; OnPropertyChagned("EmailVisibility"); }
        }

        public ICommand HideShowFields
        {
            get
            {
                return new RelayCommand<object>(new Action<object>((o) =>
                    {
                        IDVisibility = IDVisibility == Visibility.Visible ? Visibility.Collapsed : Visibility.Visible;
                        EmailVisibility = EmailVisibility == Visibility.Visible ? Visibility.Collapsed : Visibility.Visible;
                    }));
            }
        }
    }

    public class DataViewModel : PropertyChangedNotifier
    {
        private int id;

        public int ID
        {
            get { return id; }
            set { id = value; OnPropertyChagned("ID"); }
        }

        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChagned("Name"); }
        }

        private string email;

        public string Email
        {
            get { return email; }
            set { email = value; OnPropertyChagned("Email"); }
        }

        private int age;

        public int Age
        {
            get { return age; }
            set { age = value; OnPropertyChagned("Age"); }
        }
    }

    public class PropertyChangedNotifier : DependencyObject, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class RelayCommand<T> : ICommand
    {

        #region Declarations

        readonly Predicate<T> _canExecute;
        readonly Action<T> _execute;

        #endregion

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="RelayCommand&lt;T&gt;"/> class and the command can always be executed.
        /// </summary>
        /// <param name="execute">The execution logic.</param>
        public RelayCommand(Action<T> execute)
            : this(execute, null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RelayCommand&lt;T&gt;"/> class.
        /// </summary>
        /// <param name="execute">The execution logic.</param>
        /// <param name="canExecute">The execution status logic.</param>
        public RelayCommand(Action<T> execute, Predicate<T> canExecute)
        {

            if (execute == null)
                throw new ArgumentNullException("execute");
            _execute = execute;
            _canExecute = canExecute;
        }

        #endregion

        #region ICommand Members

        public virtual Boolean CanExecute(Object parameter)
        {
            return _canExecute == null ? true : _canExecute((T)parameter);
        }

        public virtual void Execute(Object parameter)
        {
            _execute((T)parameter);
        }

        #endregion


        public event EventHandler CanExecuteChanged;
    }
}
